
void slave() {
  double speed, dist, dist_l, dist_r,value_switch;
  run_state_t state;
  command_data_t command_data;
  pinMode(13,INPUT_PULLUP);
  pinMode(DIN_PIN, INPUT_PULLUP);
  int a;
  int b = 0;

  while (1) {
    if (raspi_receive(&command_data) == 0) {
      switch (command_data.val[0]) {
      case 1:
        //digitalWrite(13,HIGH);
        //servo();
        //delay(1000);
        run_ctrl_set(STP, 0, 0);
        break;
      case 2:
        run_ctrl_set(STR, command_data.val[1], command_data.val[2]);
        break;
      case 3:
        run_ctrl_set(ROT, command_data.val[1], command_data.val[2]);
        break;
      case 10:
        run_ctrl_get(&state, &speed, &dist);
        command_data.val[0] = ((state == STR) ? 2 : (state == ROT) ? 3 : 1);
        command_data.val[1] = (short)speed;
        command_data.val[2] = (short)dist;
        raspi_send(command_data);
        break;
      case 11:
        distance_get(&dist_l, &dist_r);
        command_data.val[0] = (short)dist_l;
        command_data.val[1] = (short)dist_r;
        raspi_send(command_data);
        break;
      case 12:
        command_data.val[0] = (short)(io_get_batt() * 100.0);
        raspi_send(command_data);
        break;
      case 30:
        //servo();
        //digitalWrite(13,HIGH);
        //software_reset();
        arm_start();
        break;
      case 31:
        //digitalWrite(13,LOW);
        //software_reset();
        arm_end();
        break;
      case 32:
        //software_reset();
        value_switch =digitalRead(PIN_LED);
        command_data.val[0] = (short)value_switch;
        raspi_send(command_data);


        //        b = 0;
        //        while(b == 0){ 
        //          a = digitalRead(DIN_PIN);
        //          while(a == 1){
        //            run_ctrl_set(STR, 1, 1);
        //            a = digitalRead(DIN_PIN);
        //            if(a == 0){
        //              b = 1;
        //            }
        //          }
        //        }

        break;

      default:
        break;

      }
    }
    run_ctrl_execute();
    vel_ctrl_execute();
    delay(T_CTRL);
  }
}





